---
title: Navigation Timing API
slug: Web/API/Navigation_timing_API
tags:
  - API
  - Navigation Timing
  - Navigation Timing API
  - Optimization
  - Overview
  - Performance
  - Timing
  - Web
  - Web Performance
---
<p>{{DefaultAPISidebar("Navigation Timing")}}</p>

<p><span class="seoSummary">The <strong>Navigation Timing API</strong> provides data that can be used to measure the performance of a web site. Unlike JavaScript-based libraries that have historically been used to collect similar information, the Navigation Timing API can be much more accurate and reliable.</span></p>

<div class="notecard note">
<p><strong>This article currently describes Navigation Timing Level 1.</strong> There is a specification for Level 2, but it is not yet covered here.</p>
</div>

<h2 id="Concepts_and_usage">Concepts and usage</h2>

<p>You can use the Navigation Timing API to gather performance data on the client side, which you can then transmit to a server using {{domxref("XMLHttpRequest")}} or other techniques.</p>

<p>This API lets you measure data that was previously difficult to obtain, such as the amount of time needed to unload the previous page, how long domain lookups take, the total time spent executing the window's {{event("load")}} handler, and so forth.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("Performance")}}</dt>
 <dd>The {{domxref("window.performance")}} property returns a <code>Performance</code> object. While this interface is defined by the High Resolution Time API, the Navigation Timing API adds two properties: {{domxref("Performance.timing", "timing")}} and {{domxref("Performance.navigation", "navigation")}}, of the types below.</dd>
 <dt>{{domxref("PerformanceNavigationTiming")}}</dt>
 <dd>Provides methods and properties to store and retrieve metrics regarding the browser's document navigation events. For example, this interface can be used to determine how much time it takes to load or unload a document.</dd>
 <dt>{{deprecated_inline}} {{domxref("PerformanceTiming")}}</dt>
 <dd>Used as the type for the value of {{domxref("Performance.timing", "timing")}}, objects of this type contain timing information that can provide insight into web page performance.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceNavigation")}}</dt>
 <dd>The type used to return the value of {{domxref("Performance.navigation", "navigation")}}, which contains information explaining the context of the load operation described by this <code>Performance</code> instance.</dd>
</dl>

<p>The Navigation Timing API can be used to gather performance data on the client side to be sent to a server via XHR as well as measure data that was very difficult to measure by other means such as time to unload a previous page, domain look up time, <code>window.onload</code> total time, etc.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Calculate_the_total_page_load_time">Calculate the total page load time</h3>

<p>To compute the total amount of time it took to load the page, you can use the following code:</p>

<pre class="brush: js">const perfData = window.performance.timing;
const pageLoadTime = perfData.loadEventEnd - perfData.navigationStart;
</pre>

<p>This subtracts the time at which navigation began ({{domxref("PerformanceTiming.navigationStart", "navigationStart")}}) from the time at which the {{event("load")}} event handler returns ({{domxref("PerformanceTiming.loadEventEnd", "loadEventEnd")}}). This gives you the perceived page load time.</p>

<h3 id="Calculate_request_response_time">Calculate request response time</h3>

<p>You can calculate the time elapsed between the beginning of a request and the completion of getting the response using code like this:</p>

<pre class="brush: js">const connectTime = perfData.responseEnd - perfData.requestStart;</pre>

<p>Here, the time at which the request was initiated ({{domxref("PerformanceTiming.requestStart", "requestStart")}}). from the time at which the response was finished being received ({{domxref("PerformanceTiming.responseEnd", "responseEnd")}}).</p>

<h3 id="Calculate_page_render_time">Calculate page render time</h3>

<p>As another example of an interesting piece of data you can obtain using the Navigation Timing API that you can't otherwise easily get, you can get the amount of time it took to render the page:</p>

<pre class="brush: js">const renderTime = perfData.domComplete - perfData.domLoading;</pre>

<p>This is obtained by starting with the time at which loading of the DOM and its dependencies is complete ({{domxref("PerformanceTiming.domComplete", "domComplete")}}) and subtracting from it the time at which parsing of the DOM began ({{domxref("PerformanceTiming.domLoading", "domLoading")}}).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Navigation Timing Level 2')}}</td>
   <td>{{Spec2('Navigation Timing Level 2')}}</td>
   <td>Adds <code>PerformanceNavigationTiming</code></td>
  </tr>
  <tr>
   <td>{{SpecName('Navigation Timing')}}</td>
   <td>{{Spec2('Navigation Timing')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Window.performance.timing"><code>Window.performance.timing</code></h3>

<div>

<p>{{Compat("api.PerformanceTiming")}}</p>
</div>
